/*
Origine :
Sujet      : msgbx.cc and test programs 
De         : Rick Gearardo <dbase@NO_SPAMsecuritycorp.com.com>  
Date       : 26 Oct 2004 13:45:32 -0400 
Newsgroups : dbase.binaries 
Attachment(s) msgbx4.zip 
Traduction : M.abraham - 13 novembre 2011
*/

#define mult 1.1
#define xLimit -1000000000
#define fontDefaultSize 10
#define fontWidthScaleConstant 1.2
#define fontHeightScaleConstant 1.8
#define maxNumberIndex 7
// Usage:
// set procedure to msgbx.cc additive
// form.msgbx = new msgbx
// form.msgbx.msg(t1,t2,n,b1,b2,b3,b4,b5,v1,v2,v3,v4,v5)
// t1 = message affich
// t2 = texte titre msgbx 
// n = msgbx type
// b1 -> b5 = bouton texte 
// v1 -> v5 = valeurs renvoyes - numerique ou charactere
// n = 0 -> 5 = comportement identique  msgbox()
// n = 6 affiche quatre  boutons tiquetts un -> quatre et retournant 1 -> 4 sauf si des
//		valeurs ont t donnes pour b1 - b4 et v1 -> v4 
// n = 7 idem 6 sauf qu'il y a 5 boutons
// form.msgbx.msg() peut tre appel sans paramtres 
//
// utiliser les paramtres b et v parameters remplacera les valeurs par dfaut des boutons et des valeurs rettournes
//
//
// Autres parameters:
// 14. tfn = text.fontName e.g. "helviticca"
// 15. tcn = text.colorNormal  e.g. "red/black"
// 16. tfb = text.fontBold - logical
// 17. tfi = text.fontItalic - logical
// 18. tfSo = text.fontStrikeout - logical
// 19. tfU = text.fontUnderline - logical
// 20. tfs = text.fontSize - numeric
// 21. bcn = button.colorNormal e.g. "btnText/btnFace"
// 22. fcn = form.colorNormal
// 23. tbs = text.borderStyle - numeric  0 - 10
// 24. tah = text.alignHorizontal - numeric 0 - 3
// 25. i1 = image 1 - nom de fichier et chemin d'acces entre guillemets 
// 26. i1h i1 height
// 27. i1w i1 width
// 28. i2 = image 2 - nom de fichier et chemin d'acces entre guillemets // file name  and path in quotes
// 29. i2h i2 height
// 30. i2w i2 width
//
// if n > 128 L'image i1 est place  gauche du text // the image i1 is used to the left of the text
// if n >= 256 and <= 263  Les boutons sont  gauche et il n'y a pas d'image  gauche
                         //the buttons are stacked on the left of the form and there is no left hand image
// if n >= 512 and <= 519 
                          //the buttons are stacked on the right of the form and 
//    there is no left default image although you can set a left hand image using parameter i1
// if n >= 768 and n <= 775   les boutons sont en haut
// if empty(n) or n = 0 and n <= 7 i1 est plac  gfauche du texte et
//                                 i2  droite s'il est indiqu 
// if you skip parameters us "" e.g. msg("","",6,"","","","","",40,"",60,70,"","","",true)
class msgbx
	function msg(t1,t2,n,b1,b2,b3,b4,b5,v1,v2,v3,v4,v5,tfn,tcn,tfb,tfi,tfSo,tfU,tfs,bcn,fcn,tbs,tah,i1,i1h,i1w,i2,i2h,i2w)
   	local r, a
      r = new myMsgboxform()
      r.fontWidthScale = 1
      r.fontHeightScale = 1
      r.p = 0
      if pcount() > 0
      	r.lText.text := t1
      else
      	r.lText.text := ""
      endif
      if pcount() > 1
      	r.text = t2
      else
	      r.text = ""
      endif
      if pcount() > 2
      	r.n = n
         if r.n > maxNumberIndex
         	r.p = this.getNum(n)
            r.n = n - r.p
         endif
      else
      	r.n = xLimit
      endif
		a = new array()
      if pcount() > 3
      	a.add(b1)
         r.b1 = b1
      endif
      if pcount() > 4
      	a.add(b2)
         r.b2 = b2
      endif
      if pcount() > 5
      	a.add(b3)
         r.b3 = b3
      endif
      if pcount() > 6
      	a.add(b4)
         r.b4 = b4
      endif
      if pcount() > 7
      	a.add(b5)
         r.b5 = b5
		endif
      if pcount() > 8
      	r.v1 = v1
      else 
      	r.v1 = xLimit
      endif
      if pcount() > 9
      	r.v2 = v2
      else 
      	r.v2 = xLimit
      endif
      if pcount() > 10
      	r.v3 = v3
      else 
      	r.v3 = xLimit
      endif
      if pcount() > 11
      	r.v4 = v4
      else 
      	r.v4 = xLimit
      endif
      if pcount() > 12
      	r.v5 = v5
      else 
      	r.v5 = xLimit
      endif
      if pcount() > 13 .and. .not. empty(tfn)
      	r.lText.fontName = tfn
      endif
      if pcount() > 14 .and. .not. empty(tcn)
      	r.lText.colorNormal = tcn 
      endif
      if pcount() > 15 .and. .not. empty(tfb)
      	r.lText.fontBold := tfb
      endif 
      if pcount() > 16 .and. .not. empty(tfi)
      	r.lText.fontItalic := tfi
      endif
      if pcount() > 17 .and. .not. empty(tfso)
      	r.lText.fontStrikeout := tfso
      endif
      if pcount() > 18 .and. .not. empty(tfu)
      	r.lText.fontUnderline := tfu
      endif
      if pcount() > 19 .and. .not. empty(tfs)
      	r.lText.fontSize = tfs
         r.fontHeightScale = tfs/fontDefaultSize * fontHeightScaleConstant
         r.fontWidthScale = fontWidthScaleConstant
      else
      	r.fontHeightScale = 1
         r.fontWidthScale = 1
      endif
      if pcount() > 20 .and. .not. empty(bcn)
      	r.bcn = bcn
      else
      	r.bcn = null
      endif
      if pcount() > 21 .and. .not. empty(fcn)
      	r.colorNormal = fcn
      endif
      if pcount() > 22 .and. .not. empty(tbs) .and. tbs >=0 .and. tbs <= 10
      	r.lText.border := true
      	r.lText.borderStyle := tbs
         r.tbs = tbs
      endif
      if pcount() > 23 .and. .not. empty(tah) .and. tah >= 0 .and. tah <= 3 
      	r.lText.alignHorizontal := tah
      endif
      if pcount() > 24 .and. .not. empty(i1) 
      	r.image1 = i1
         r.i1h = 2
         r.i1w = 5
         if pcount() > 25 .and. .not. empty(i1h)
         	r.i1h = i1h
         endif
         if pcount() > 26 .and. .not. empty(i1w)
         	r.i1w = i1w
         endif
      else
      	r.image1 = null
      endif
      if pcount() > 27 .and. .not. empty(i2) 
      	r.image2 = i2
         if pcount() > 28 .and. .not. empty(i2h)
         	r.i2h = i2h
			else
         	r.i2h = 2
         endif
         if pcount() > 29 .and. .not. empty(i2w)
         	r.i2w = i2w
         else
         	r.i2w = 5
         endif
      else
      	r.image2 = null
      endif
      r.l = 0
      r.l = this.getLongest(a)
      r.readModal()
      return(r.rVal)

      func getNum(n)
      	local rVal
         rVal = 0
         if n - 16 <= maxNumberIndex .and. n - 16 >= 0
         	rVal = 16
         elseif n - 32 <= maxNumberIndex .and. n - 32 >= 0
         	rVal = 32
         elseif n - 48 <= maxNumberIndex .and. n - 48 >= 0
         	rVal = 48
         elseif n - 64 <= maxNumberIndex .and. n - 64 >= 0
         	rVal = 64       
         elseif n - 128 <= maxNumberIndex .and. n - 128 >= 0
         	rVal = 128
         elseif n - 256 <= maxNumberIndex .and. n - 256 >= 0
         	rVal = 256
         elseif n - 512 <= maxNumberIndex .and. n - 512 >= 0
         	rVal = 512       
         elseif n - 768 <= maxNumberIndex .and. n - 768 >= 0
         	rVal = 768       
      	endif
         return(rVal)

      func getLongest(a)
      	local r, i
			r = 0
         for i = 1 to a.size
         	if len(a[i]) > r
            	r = len(a[i])
            endif
         next
         if mult * r < 7
         	r = 7
         endif
         return(r)

endclass

class mymsgboxForm of FORM
    with (this)
    	onOpen = class::FORM_ONOPEN
    	readModal = class::READMODAL
      left = 29.1429
      top = 2.7727
      text = ""
      topMost = true
      autoCenter = true
      mdi = false
      sysMenu = false
      escExit = false
      maximize = false
      minimize = false
      autosize = true
      smallTitle = true
   endwith

   this.lText = new text(this)
   with(this.lText)
		top = .25
      alignHorizontal = 1
      wrap = true
      left = 1

   endwith


   func readModal()
   	form.init()
      return super::READMODAL()

   proc calclTextSize
   	local  r, w, l
      w = form.nb * form.pbOne.width + (form.nb - 1)
      if w < 23
      	w := 23
      endif
      l = len(trim(form.lText.text)) * form.fontWidthScale
      r = (int(l/w) * .77 + .77) * form.fontHeightScale
      if form.lText.fontSize >= 25
      	r = r + 1
         w = w + 5
      endif
		r++
      form.lText.height := r
      form.lText.width := w
      if form.p = 256
			form.lText.left := (form.l * mult) + .5
      else
      	form.lText.left := form.ltext.left + form.leftOffset
      endif
      if form.p = 768
      	form.lText.top = 1.0909 + .5
      endif

   proc setButtonTop(t,n)
   	local i
      for i = 1 to n
         if form.p = 256
         	form.a[i].top = (i - 1) * form.pbOne.Height
            form.a[i].left = .5
         elseif form.p = 512
         	form.a[i].top = (i - 1) * form.pbOne.Height
            form.a[i].left = form.lText.left + form.lText.width +  .5
      	else
      		form.a[i].top = max(max(t,form.topOffset),max(form.im1offSet,form.im2Offset))
				if form.p = 768
         		form.a[i].top = 0
         	endif
         endif
      next


	proc form_onOpen
   	if form.p = 256 .or. form.p = 512
      	form.lText.height := form.height - form.lText.top
      else
         if form.nb = 1
            form.pbOne.left := form.width/2 - form.pbOne.width/2
         elseif form.nb = 2
            form.pbOne.left := form.width/2 - form.pbOne.width - .5
            form.pbTwo.left := form.width/2 + .5
         elseif form.nb = 3
            form.pbTwo.left := form.width/2 - form.pbOne.width/2
            form.pbThree.left := form.pbTwo.left + form.pbTwo.width + 1
            form.pbOne.left := form.pbTwo.left - form.pbThree.width - 1
         elseif form.nb = 4
            form.pbTwo.left := form.width/2 - form.pbTwo.width - .5
            form.pbOne.left := form.pbTwo.left - form.pbOne.width - 1
            form.pbThree.left := form.pbTwo.left + form.pbTwo.width + 1
            form.pbFour.left := form.pbThree.left + form.pbThree.width + 1
         elseif form.nb = 5
            form.pbThree.left := form.width/2 - form.pbOne.width/2
            form.pbFour.left := form.pbThree.left + form.pbThree.width + 1
            form.pbTwo.left := form.pbThree.left - form.pbTwo.width - 1
            form.pbOne.left := form.pbTwo.left - form.pbOne.width - 1
            form.pbFive.left := form.pbFour.left + form.pbFive.width + 1
         endif
      endif

   proc setImage(p)
   	if form.p <> 256
         form.dImage = new image(form)
         with(form.dImage)
            top = .25
            left = .5
            width = 5
            height = 2
            borderStyle = 3
         endwith

         if p = 16
            form.dImage.dataSource = "RESOURCE #1077"
         elseif p = 32
            form.dImage.dataSource = "RESOURCE #124"
         elseif p = 48
            form.dImage.dataSource = "RESOURCE #120"
         elseif p = 64
            form.dImage.dataSource = "RESOURCE #132"
         elseif p = 128 .and. form.image1 <> null
            form.dImage.dataSource = "FILENAME " + form.image1
         endif
         form.leftOffset = form.dImage.left + form.dImage.width + .5
         form.topOffset = form.dImage.top + form.dImage.height
      endif

   proc setImage2
   	if form.p <> 512
         form.im2 = new image(form)
         with(form.im2)
            top = .25
            borderStyle = 3
            width = form.i2w
            height = form.i2h
            dataSource = "FILENAME " + form.image2
         endwith
         form.im2Offset = form.im2.top + form.im2.height
      endif

   proc setImage1
   	if form.p <> 256
         local h, w
         form.im1 = new image(form)
         with(form.im1)
            top = .25
            borderStyle = 3
            width = form.i1w
            height = form.i1h
            form.left = .5
            dataSource = "FILENAME " + form.image1
         endwith
         form.im1Offset = form.im1.top + form.im1.height
         form.leftOffset = form.im1.left + form.im1.width + .5
      endif

   proc init
   	form.leftOffset = 0
      form.topOffSet = 0
      form.im1Offset = 0
      form.im2Offset = 0
   	if form.p > 0 .and. form.p < 256
      	form.setImage(form.p)
      endif
      if (form.p = 0 .or. form.p = 512 .or. form.p = 768) .and. form.image1 <> null
      	form.setImage1()
      endif
      if form.image2 <> null
      	form.setImage2()
      endif
      form.nb = 0
      form.a = new array()
      form.setButtons()
      form.calclTextSize()
      form.setButtonTop(form.lText.height + 1, form.nb)
      if type("form.im2") <> "U"
      	form.im2.left = form.lText.width + form.ltext.left + .5
      endif

   proc setButtons
   	local bcn
   	if form.bcn <> null
      	bcn = form.bcn
      else
      	bcn = "btnText/btnface"
      endif

      if form.n = 0
      	form.makePbOne("OK",bcn)
         if form.v1 <> xLimit
         	form.i1 = form.v1
         else
         	form.i1 = 1
         endif
         form.nb := 1
      elseif form.n = 1
      	form.makePbOne("OK",bcn)
         if form.v1 <> xLimit
         	form.i1 = form.v1
         else
         	form.i1 = 1
         endif
         form.makePbTwo("Cancel",bcn)
         if form.v2 <> xLimit
         	form.i2 = form.v2
         else
         	form.i2 = 2
         endif
         form.nb := 2
      elseif form.n = 2
      	form.makePbOne("Abandon",bcn)
			if form.v1 <> xLimit
         	form.i1 = form.v1
         else
         	form.i1 = 3
         endif
         form.makePbTwo("Retente",bcn)
			if form.v2 <> xLimit
         	form.i2 = form.v2
         else
         	form.i2 = 4
         endif
         form.makePbThree("Ignore",bcn)
			if form.v3 <> xLimit
         	form.i3 = form.v3
         else
         	form.i3 = 5
         endif 
         form.nb := 3
      elseif form.n = 3
      	form.makePbOne("Oui",bcn)
			if form.v1 <> xLimit
         	form.i1 = form.v1
         else
         	form.i1 = 6
         endif
         form.makePbTwo("Non",bcn)
			if form.v2 <> xLimit
         	form.i2 = form.v2
         else
         	form.i2 = 7
         endif
         form.makePbThree("Abandon",bcn)
			if form.v3 <> xLimit
         	form.i3 = form.v3
         else
         	form.i3 = 2
         endif 
         form.nb := 3
      elseif form.n = 4
      	form.makePbOne("Oui",bcn)
 			if form.v1 <> xLimit
         	form.i1 = form.v1
         else
	         form.i1 = 6
         endif
         form.makePbTwo("Non",bcn)
			if form.v2 <> xLimit
         	form.i2 = form.v2
         else
	         form.i2 = 7
         endif
         form.nb := 2
      elseif form.n = 5
      	form.makePbOne("Retente",bcn)
			if form.v1 <> xLimit
         	form.i1 = form.v1
         else
	         form.i1 = 4
         endif
         form.makePbTwo("Abandon",bcn)
			if form.v2 <> xLimit
         	form.i2 = form.v2
         else
	         form.i2 = 2
         endif
         form.nb := 2
      elseif form.n = 6
      	form.makePbOne("Un",bcn)
			if form.v1 <> xLimit
         	form.i1 = form.v1
         else
	         form.i1 = 1
         endif
         form.makePbTwo("Deux",bcn)
			if form.v2 <> xLimit
         	form.i2 = form.v2
         else
	         form.i2 = 2
         endif
         form.makePbThree("Trois",bcn)
			if form.v3 <> xLimit
         	form.i3 = form.v3
         else
	         form.i3 = 3
         endif
         form.makePbFour("Quatre",bcn)
			if form.v4 <> xLimit
         	form.i4 = form.v4
         else
	         form.i4 = 4
         endif
         form.nb := 4
     elseif form.n = 7
      	form.makePbOne("Un",bcn)
			if form.v1 <> xLimit
         	form.i1 = form.v1
         else
	         form.i1 = 1
         endif
         form.makePbTwo("Deux",bcn)
			if form.v2 <> xLimit
         	form.i2 = form.v2
         else
	         form.i2 = 2
         endif
         form.makePbThree("Trois",bcn)
			if form.v3 <> xLimit
         	form.i3 = form.v3
         else
	         form.i3 = 3
         endif
         form.makePbFour("Quatre",bcn)
			if form.v4 <> xLimit
         	form.i4 = form.v4
         else
	         form.i4 = 4
         endif  
         form.makePbFive("Cinq",bcn)
			if form.v5 <> xLimit
         	form.i5 = form.v5
         else
	         form.i5 = 5
         endif  
         form.nb := 5
      else
      	form.makePbOne("OK",bcn)
			if form.v1 <> xLimit
         	form.i1 = form.v1
         else
	         form.i1 = 1
         endif
         form.nb := 1
      endif


   proc makePbOne(t,bcn)
      form.pbOne = new pushbutton(form)
      with(form.pbOne)
         onClick = {;form.rVal = form.i1;form.close()}
			colorNormal = bcn
         height = 1.0909
         left = 1
         text = t
      endwith
      if form.l <> 0
         form.pbOne.width := mult * form.l
      endif
      if type("form.b1") ="C" .and. .not. empty(form.b1)
		 	form.pbOne.text := form.b1
      endif
      form.a.add(form.pbOne)

   proc makePbTwo(t,bcn)
      form.pbTwo = new pushbutton(form)
      with(form.pbTwo)
         onClick = {;form.rVal = form.i2;form.close()}
			colorNormal = bcn
         height = 1.0909
			left = form.pbOne.width + 2
         text = t
      endwith
      if form.l <> 0
         form.pbTwo.width := form.pbOne.width
      endif
      if type("form.b2") ="C" .and. .not. empty(form.b2)
		 	form.pbTwo.text := form.b2
      endif
      form.a.add(form.pbTwo)

   proc makePbThree(t,bcn)
      form.pbThree = new pushbutton(form)
      with(form.pbThree)
         onClick = {;form.rVal = form.i3;form.close()}
			colorNormal = bcn
         height = 1.0909
			left = 2 * form.pbOne.width + 3
         text = t
      endwith
      if form.l <> 0
         form.pbThree.width := form.pbOne.width
      endif
      if type("form.b3") ="C" .and. .not. empty(form.b3)
		 	form.pbThree.text := form.b3
      endif
      form.lText.width = 3 * form.pbOne.width + 2
      form.a.add(form.pbThree)

   proc makePbFour(t,bcn)
      form.pbFour = new pushbutton(form)
      with(form.pbFour)
         onClick = {;form.rVal = form.i4;form.close()}
			colorNormal = bcn
         height = 1.0909
			left = 3 * form.pbOne.width + 4
         text = t
      endwith
      if form.l <> 0
         form.pbFour.width := form.pbOne.width
      endif
      if type("form.b4") ="C" .and. .not. empty(form.b4)
		 	form.pbFour.text := form.b4
      endif
      form.a.add(form.pbFour)

   proc makePbFive(t,bcn)
      form.pbFive = new pushbutton(form)
      with(form.pbFive)
         onClick = {;form.rVal = form.i5;form.close()}
			colorNormal = bcn
         height = 1.0909
			left = 4 * form.pbOne.width + 5
         text = t
      endwith
      if form.l <> 0
         form.pbFive.width := form.pbOne.width
      endif
      if type("form.b5") ="C" .and. .not. empty(form.b5)
		 	form.pbFive.text := form.b5
      endif
      form.a.add(form.pbFive)
endclass

